<?php
add_action( 'tgmpa_register', 'precise_register_required_plugins' );


if(!function_exists('lasf_get_plugin_source')){
    function lasf_get_plugin_source( $new, $initial, $plugin_name, $type = 'source'){
        if(isset($new[$plugin_name], $new[$plugin_name][$type]) && version_compare($initial[$plugin_name]['version'], $new[$plugin_name]['version']) < 0 ){
            return $new[$plugin_name][$type];
        }
        else{
            return $initial[$plugin_name][$type];
        }
    }
}

if(!function_exists('precise_register_required_plugins')){

	function precise_register_required_plugins() {

        $initial_required = array(
            'lastudio-core' => array(
                'source'    => 'https://la-studioweb.com/file-resouces/precise/plugins/lastudio-core/2.2.5/lastudio-core.zip',
                'version'   => '2.2.5'
            ),
            'precise-demo-data' => array(
                'source'    => 'https://la-studioweb.com/file-resouces/precise/plugins/precise-demo-data/1.0.1/precise-demo-data.zip',
                'version'   => '1.0.1'
            ),
            'revslider' => array(
                'source'    => 'https://la-studioweb.com/file-resouces/shared/plugins/revslider/6.5.4/revslider.zip',
                'version'   => '6.5.4'
            ),
            'js_composer' => array(
                'source'    => 'https://la-studioweb.com/file-resouces/shared/plugins/js_composer/6.7.0/js_composer.zip',
                'version'   => '6.7.0'
            )
        );

        $from_option = get_option('precise_required_plugins_list', $initial_required);

		$plugins = array();

		$plugins[] = array(
			'name'					=> esc_html_x('WPBakery Visual Composer', 'admin-view', 'precise'),
			'slug'					=> 'js_composer',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'js_composer'),
            'required'				=> true,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'js_composer', 'version')
		);

		$plugins[] = array(
			'name'					=> esc_html_x('LA Studio Core', 'admin-view', 'precise'),
			'slug'					=> 'lastudio-core',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio-core'),
            'required'				=> true,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'lastudio-core', 'version')
		);
		$plugins[] = array(
			'name'					=> esc_html_x('Precise Package Demo Data', 'admin-view', 'precise'),
			'slug'					=> 'precise-demo-data',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'precise-demo-data'),
            'required'				=> true,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'precise-demo-data', 'version')
		);


		$plugins[] = array(
			'name'     				=> esc_html_x('WooCommerce', 'admin-view', 'precise'),
			'slug'     				=> 'woocommerce',
			'version'				=> '5.5.0',
			'required' 				=> false
		);

		$plugins[] = array(
			'name'					=> esc_html_x('Slider Revolution', 'admin-view', 'precise'),
			'slug'					=> 'revslider',
            'source'				=> lasf_get_plugin_source($from_option, $initial_required, 'revslider'),
            'required'				=> false,
            'version'				=> lasf_get_plugin_source($from_option, $initial_required, 'revslider', 'version')
		);

		$plugins[] = array(
			'name'     				=> esc_html_x('Envato Market', 'admin-view', 'precise'),
			'slug'     				=> 'envato-market',
			'source'   				=> 'https://envato.github.io/wp-envato-market/dist/envato-market.zip',
			'required' 				=> false,
			'version' 				=> '2.0.5'
		);

		$plugins[] = array(
			'name' 					=> esc_html_x('Contact Form 7', 'admin-view', 'precise'),
			'slug' 					=> 'contact-form-7',
			'required' 				=> false
		);

		$plugins[] = array(
			'name'     				=> esc_html_x('YITH WooCommerce Wishlist', 'admin-view', 'precise'),
			'slug'     				=> 'yith-woocommerce-wishlist',
			'required' 				=> false
		);

		$plugins[] = array(
			'name'     				=> esc_html_x('YITH WooCommerce Compare', 'admin-view', 'precise'),
			'slug'     				=> 'yith-woocommerce-compare',
			'required' 				=> false
		);

		$plugins[] = array(
			'name'     				=> esc_html_x('YITH WooCommerce Social Login', 'admin-view', 'precise'),
			'slug'     				=> 'yith-woocommerce-social-login',
			'required' 				=> false
		);

		$plugins[] = array(
			'name' 					=> esc_html_x('Easy Forms for MailChimp by YIKES', 'admin-view', 'precise'),
			'slug' 					=> 'yikes-inc-easy-mailchimp-extender',
			'required' 				=> false
		);

		$config = array(
			'id'           				=> 'precise',
			'default_path' 				=> '',
			'menu'         				=> 'tgmpa-install-plugins',
			'has_notices'  				=> true,
			'dismissable'  				=> true,
			'dismiss_msg'  				=> '',
			'is_automatic' 				=> false,
			'message'      				=> ''
		);

		tgmpa( $plugins, $config );

	}

}